CREATE TABLE `locations` (
  `dt` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `accuracy` int(11) DEFAULT NULL,
  `altitude` int(11) DEFAULT NULL,
  `battery_level` int(11) DEFAULT NULL,
  `heading` int(11) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `event` varchar(255) DEFAULT NULL,
  `latitude` decimal(9,6) DEFAULT NULL,
  `longitude` decimal(9,6) DEFAULT NULL,
  `radius` int(11) DEFAULT NULL,
  `trig` varchar(1) DEFAULT NULL,
  `tracker_id` varchar(255) DEFAULT NULL,
  `epoch` int(11) DEFAULT NULL,
  `vertical_accuracy` int(11) DEFAULT NULL,
  `velocity` float DEFAULT NULL,
  `pressure` decimal(9,6) DEFAULT NULL,
  `connection` varchar(1) DEFAULT NULL,
  `topic` varchar(255) NOT NULL,
  `place_id` int(11) DEFAULT NULL,
  `osm_id` int(11) DEFAULT NULL,
  `display_name` text DEFAULT NULL,
  KEY `accuracy_index` (`accuracy`),
  KEY `tracker_id` (`tracker_id`,`epoch`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
